#include <iostream>
#include <iterator>
#include <opencv2/opencv.hpp>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
//#include <chrono>

using namespace cv;
using namespace std;
using namespace std::chrono; 


struct RGB
{
    RGB(int NN, int rr=0, int gg=0, int bb=0):N(NN), r(rr), g(gg), b(bb) {}
    bool operator <(const RGB& rhs) const 
    {
        return N<rhs.N ;
    }
    bool operator >(const RGB& rhs) const 
    {
        return N>rhs.N ;
    }
    int N,r,g,b; 
};

void ReadRGBData(vector<RGB>& v, const string& fname)
{
    ifstream ifs (fname.c_str());
    string line;
    int N,r,g,b;
    while(ifs >> N >> r >> g >> b)
    {
        v.push_back(RGB(N,r,g,b));
    }
}


void VisualizeData(vector<RGB>& data)
{
    int num_colors = data.size();
    int im_size = num_colors*2;
    Mat img(im_size, im_size, CV_8UC3, Scalar(255,255,255));
    int R, G, B, cen, rect_size;
    Point pt1, pt2;
    Scalar color;
    // ---------- FILL IN ----------- 

    // ----------------------
    imwrite( "image.jpg", img );
}



// A function to implement bubble sort  
void bubbleSort(vector<RGB>& arr, int n)  
{  
    // ---------- FILL IN -----------

    // ----------------------
}  


int main(int argc, char** argv )
{
    string name="colors.txt";
    ifstream file(name);
    vector<RGB> data;
    ReadRGBData(data,name);
    auto start = high_resolution_clock::now();
    bubbleSort(data,data.size());
    //sort(data.begin(),data.end()); - evaluate against an implemented sorting algorithm
    auto stop = high_resolution_clock::now();
    auto duration = duration_cast<microseconds>(stop - start); // use to evaluate the running time of the sorting algorithm
    cout << duration.count();
    VisualizeData(data);
    return 0;
}
